// Add channels here
// Syntax is
// add_channel("channel name",pdfs,ndim,integrand function);
// name: channel name, used in config file
// pdfs: one of GG,QG,QB,QQ,QP
// ndim: integration dimension (number of integration variables for the partonic cross section)
// integrand function: has the interface
//		double function_name(double integration_variables[], double sqrs, std::function<double(double)> get_pdfs, const channel * ch)
// 		where integration_variables[i] is in [0,1] and 0 <= i < ndim,
// 		sqrs = (partonic) Sqrt[s]
// 		get_pdfs = a function that takes the factorisation scale squared and returns the product of the pdfs. The function is provided by ggzh
// 		ch = a pointer to the channel object

//add_channel("test",GG,1,testchannel);

add_channel("LO_0",GG,1,LO_0);
add_channel("LO_2",GG,1,LO_2);
add_channel("LO_4",GG,1,LO_4);
add_channel("LO_6",GG,1,LO_6);
add_channel("LO_8",GG,1,LO_8);
add_channel("LO_10",GG,1,LO_10);

add_channel("LO_exact",GG,1,LO_exact);

add_channel("NLO_phase2_0",GG,1,NLO_phase2_0);
add_channel("NLO_phase2_2",GG,1,NLO_phase2_2);
add_channel("NLO_phase2_4",GG,1,NLO_phase2_4);
add_channel("NLO_phase2_6",GG,1,NLO_phase2_6);
add_channel("NLO_phase2_8",GG,1,NLO_phase2_8);

add_channel("NLO_phase2eta_0",GG,2,NLO_phase2eta_0);
add_channel("NLO_phase2eta_2",GG,2,NLO_phase2eta_2);
add_channel("NLO_phase2eta_4",GG,2,NLO_phase2eta_4);
add_channel("NLO_phase2eta_6",GG,2,NLO_phase2eta_6);
add_channel("NLO_phase2eta_8",GG,2,NLO_phase2eta_8);

add_channel("NLO_reducible_0",GG,1,NLO_reducible_0);
add_channel("NLO_reducible_2",GG,1,NLO_reducible_2);
add_channel("NLO_reducible_4",GG,1,NLO_reducible_4);
add_channel("NLO_reducible_6",GG,1,NLO_reducible_6);
add_channel("NLO_reducible_8",GG,1,NLO_reducible_8);
add_channel("NLO_reducible_exact",GG,1,NLO_reducible_exact);

add_channel("NLO_phase3_0",GG,4,NLO_phase3_0);
add_channel("NLO_phase3_2",GG,4,NLO_phase3_2);
add_channel("NLO_phase3_4",GG,4,NLO_phase3_4);
add_channel("NLO_phase3_6",GG,4,NLO_phase3_6);
add_channel("NLO_phase3_8",GG,4,NLO_phase3_8);

add_channel("NLO_differential_phase2",GG,1,NLO_differential_phase2);
add_channel("NLO_differential_phase2eta",GG,2,NLO_differential_phase2eta);
add_channel("NLO_differential_reducible",GG,1,NLO_differential_reducible);

add_channel("pade22_LO",GG,1,pade22_LO);
add_channel("pade22_NLO_phase2",GG,1,pade22_NLO_phase2);
add_channel("pade22_NLO_phase2eta",GG,2,pade22_NLO_phase2eta);
add_channel("pade22_NLO_reducible",GG,2,pade22_NLO_reducible);
add_channel("pade22_NLO_phase3",GG,4,pade22_NLO_phase3);
add_channel("pade22_LO_NLO_sum",GG,4,pade22_LO_NLO_sum); //LO+NLO (without reducible)
add_channel("pade22_NLO_sum",GG,4,pade22_NLO_sum); //NLO (without reducible)
