#include "LO.h"
#include "phase2.h"
#include "../src/params.h"
#include "../src/def_params.h"
#include "../src/channel.h"

double LO_ampsq(unsigned int inv_mt_pow, double sp12, double sp13, double sp23, double alphas){
	switch (inv_mt_pow){
		case 0: 
		{
			double ampsq = pow(alpha,2)*pow(alphas,2)*pow(cw2,-2)*pow(sw2,-2)*rat(
				- 8*pow(mz,2)*sp12 + 4*pow(sp13,2) + 8*sp13*sp23 + 4*pow(sp23,2)
				,pow(mz,4));
			//double ampsq = kaellen_function(2*sp12,mz*mz,mh*mh)*pow(alpha,2)*pow(alphas,2)*pow(cw2,-2)*pow(sw2,-2)/pow(mz,4);
			return ampsq;
		}
		case 2:
			return 0;
		case 4:
		{
			double ampsq = pow(alpha,2)*pow(alphas,2)*pow(cw2,-2)*pow(sw2,-2)*rat(
				12*pow(mz,4)*pow(sp12,2) + 12*pow(mz,2)*pow(sp12,2)*sp13 + 12*
				pow(mz,2)*pow(sp12,2)*sp23 - 8*pow(mz,2)*sp12*pow(sp13,2) - 8*
				pow(mz,2)*sp12*sp13*sp23 - 8*pow(mz,2)*sp12*pow(sp23,2) - 8*sp12*
				pow(sp13,3) - 16*sp12*pow(sp13,2)*sp23 - 16*sp12*sp13*pow(sp23,2)
				- 8*sp12*pow(sp23,3),15*pow(mz,4));
			return ampsq;
		}
		case 6:
		{
			double ampsq = pow(alpha,2)*pow(alphas,2)*pow(cw2,-2)*pow(sw2,-2)*rat(
				72*pow(mz,6)*pow(sp12,2) + 104*pow(mz,4)*pow(sp12,3) + 144*pow(
				mz,4)*pow(sp12,2)*sp13 + 144*pow(mz,4)*pow(sp12,2)*sp23 - 60*pow(
				mz,4)*sp12*pow(sp13,2) - 24*pow(mz,4)*sp12*sp13*sp23 - 60*pow(
				mz,4)*sp12*pow(sp23,2) + 120*pow(mz,2)*pow(sp12,3)*sp13 + 120*
				pow(mz,2)*pow(sp12,3)*sp23 + 32*pow(mz,2)*pow(sp12,2)*pow(sp13,2)
				+ 48*pow(mz,2)*pow(sp12,2)*sp13*sp23 + 32*pow(mz,2)*pow(sp12,2)*
				pow(sp23,2) - 120*pow(mz,2)*sp12*pow(sp13,3) - 168*pow(mz,2)*sp12
				*pow(sp13,2)*sp23 - 168*pow(mz,2)*sp12*sp13*pow(sp23,2) - 120*
				pow(mz,2)*sp12*pow(sp23,3) - 72*pow(sp12,2)*pow(sp13,3) - 168*
				pow(sp12,2)*pow(sp13,2)*sp23 - 168*pow(sp12,2)*sp13*pow(sp23,2)
				- 72*pow(sp12,2)*pow(sp23,3) - 72*sp12*pow(sp13,4) - 160*sp12*
				pow(sp13,3)*sp23 - 176*sp12*pow(sp13,2)*pow(sp23,2) - 160*sp12*
				sp13*pow(sp23,3) - 72*sp12*pow(sp23,4),315*pow(mz,4));
			return ampsq;
		}
		case 8:
		{
			double ampsq = pow(alpha,2)*pow(alphas,2)*pow(cw2,-2)*pow(sw2,-2)*rat(
				900*pow(mz,8)*pow(sp12,2) + 1520*pow(mz,6)*pow(sp12,3) + 2700*
				pow(mz,6)*pow(sp12,2)*sp13 + 2700*pow(mz,6)*pow(sp12,2)*sp23 - 
				900*pow(mz,6)*sp12*pow(sp13,2) - 900*pow(mz,6)*sp12*pow(sp23,2)
				+ 2040*pow(mz,4)*pow(sp12,4) + 3633*pow(mz,4)*pow(sp12,3)*sp13
				+ 3633*pow(mz,4)*pow(sp12,3)*sp23 + 2504*pow(mz,4)*pow(sp12,2)*
				pow(sp13,2) + 3945*pow(mz,4)*pow(sp12,2)*sp13*sp23 + 2504*pow(
				mz,4)*pow(sp12,2)*pow(sp23,2) - 2700*pow(mz,4)*sp12*pow(sp13,3)
				- 2700*pow(mz,4)*sp12*pow(sp13,2)*sp23 - 2700*pow(mz,4)*sp12*
				sp13*pow(sp23,2) - 2700*pow(mz,4)*sp12*pow(sp23,3) + 2520*pow(
				mz,2)*pow(sp12,4)*sp13 + 2520*pow(mz,2)*pow(sp12,4)*sp23 + 1428*
				pow(mz,2)*pow(sp12,3)*pow(sp13,2) + 2490*pow(mz,2)*pow(sp12,3)*
				sp13*sp23 + 1428*pow(mz,2)*pow(sp12,3)*pow(sp23,2) - 696*pow(
				mz,2)*pow(sp12,2)*pow(sp13,3) - 1770*pow(mz,2)*pow(sp12,2)*pow(
				sp13,2)*sp23 - 1770*pow(mz,2)*pow(sp12,2)*sp13*pow(sp23,2) - 696*
				pow(mz,2)*pow(sp12,2)*pow(sp23,3) - 3240*pow(mz,2)*sp12*pow(
				sp13,4) - 5718*pow(mz,2)*sp12*pow(sp13,3)*sp23 - 6070*pow(mz,2)*
				sp12*pow(sp13,2)*pow(sp23,2) - 5718*pow(mz,2)*sp12*sp13*pow(
				sp23,3) - 3240*pow(mz,2)*sp12*pow(sp23,4) - 1440*pow(sp12,3)*pow(
				sp13,3) - 3600*pow(sp12,3)*pow(sp13,2)*sp23 - 3600*pow(sp12,3)*
				sp13*pow(sp23,2) - 1440*pow(sp12,3)*pow(sp23,3) - 1668*pow(
				sp12,2)*pow(sp13,4) - 4776*pow(sp12,2)*pow(sp13,3)*sp23 - 5964*
				pow(sp12,2)*pow(sp13,2)*pow(sp23,2) - 4776*pow(sp12,2)*sp13*pow(
				sp23,3) - 1668*pow(sp12,2)*pow(sp23,4) - 1440*sp12*pow(sp13,5) - 
				3600*sp12*pow(sp13,4)*sp23 - 4560*sp12*pow(sp13,3)*pow(sp23,2) - 
				4560*sp12*pow(sp13,2)*pow(sp23,3) - 3600*sp12*sp13*pow(sp23,4) - 
				1440*sp12*pow(sp23,5) + 28*pow(sp13,4)*pow(sp23,2) - 56*pow(
				sp13,3)*pow(sp23,3) + 28*pow(sp13,2)*pow(sp23,4),14175*pow(mz,4));
			return ampsq;
		}
		case 10:
		{
			double ampsq = pow(alpha,2)*pow(alphas,2)*pow(cw2,-2)*pow(sw2,-2)*rat(
				2700*pow(mz,10)*pow(sp12,2) + 5151*pow(mz,8)*pow(sp12,3) + 10800*
				pow(mz,8)*pow(sp12,2)*sp13 + 10800*pow(mz,8)*pow(sp12,2)*sp23 - 
				3150*pow(mz,8)*sp12*pow(sp13,2) + 900*pow(mz,8)*sp12*sp13*sp23 - 
				3150*pow(mz,8)*sp12*pow(sp23,2) + 8330*pow(mz,6)*pow(sp12,4) + 
				18987*pow(mz,6)*pow(sp12,3)*sp13 + 18987*pow(mz,6)*pow(sp12,3)*
				sp23 + 17337*pow(mz,6)*pow(sp12,2)*pow(sp13,2) + 26958*pow(mz,6)*
				pow(sp12,2)*sp13*sp23 + 17337*pow(mz,6)*pow(sp12,2)*pow(sp23,2)
				- 12600*pow(mz,6)*sp12*pow(sp13,3) - 9000*pow(mz,6)*sp12*pow(
				sp13,2)*sp23 - 9000*pow(mz,6)*sp12*sp13*pow(sp23,2) - 12600*pow(
				mz,6)*sp12*pow(sp23,3) + 10080*pow(mz,4)*pow(sp12,5) + 21756*pow(
				mz,4)*pow(sp12,4)*sp13 + 21756*pow(mz,4)*pow(sp12,4)*sp23 + 22514
				*pow(mz,4)*pow(sp12,3)*pow(sp13,2) + 38808*pow(mz,4)*pow(sp12,3)*
				sp13*sp23 + 22514*pow(mz,4)*pow(sp12,3)*pow(sp23,2) + 7017*pow(
				mz,4)*pow(sp12,2)*pow(sp13,3) + 12543*pow(mz,4)*pow(sp12,2)*pow(
				sp13,2)*sp23 + 12543*pow(mz,4)*pow(sp12,2)*sp13*pow(sp23,2) + 
				7017*pow(mz,4)*pow(sp12,2)*pow(sp23,3) - 22680*pow(mz,4)*sp12*
				pow(sp13,4) - 32592*pow(mz,4)*sp12*pow(sp13,3)*sp23 - 33324*pow(
				mz,4)*sp12*pow(sp13,2)*pow(sp23,2) - 32592*pow(mz,4)*sp12*sp13*
				pow(sp23,3) - 22680*pow(mz,4)*sp12*pow(sp23,4) + 12960*pow(mz,2)*
				pow(sp12,5)*sp13 + 12960*pow(mz,2)*pow(sp12,5)*sp23 + 10668*pow(
				mz,2)*pow(sp12,4)*pow(sp13,2) + 19584*pow(mz,2)*pow(sp12,4)*sp13*
				sp23 + 10668*pow(mz,2)*pow(sp12,4)*pow(sp23,2) + 1308*pow(mz,2)*
				pow(sp12,3)*pow(sp13,3) + 1860*pow(mz,2)*pow(sp12,3)*pow(sp13,2)*
				sp23 + 1860*pow(mz,2)*pow(sp12,3)*sp13*pow(sp23,2) + 1308*pow(
				mz,2)*pow(sp12,3)*pow(sp23,3) - 10944*pow(mz,2)*pow(sp12,2)*pow(
				sp13,4) - 32948*pow(mz,2)*pow(sp12,2)*pow(sp13,3)*sp23 - 39768*
				pow(mz,2)*pow(sp12,2)*pow(sp13,2)*pow(sp23,2) - 32948*pow(mz,2)*
				pow(sp12,2)*sp13*pow(sp23,3) - 10944*pow(mz,2)*pow(sp12,2)*pow(
				sp23,4) - 20160*pow(mz,2)*sp12*pow(sp13,5) - 42672*pow(mz,2)*sp12
				*pow(sp13,4)*sp23 - 52236*pow(mz,2)*sp12*pow(sp13,3)*pow(sp23,2)
				- 52236*pow(mz,2)*sp12*pow(sp13,2)*pow(sp23,3) - 42672*pow(mz,2)
				*sp12*sp13*pow(sp23,4) - 20160*pow(mz,2)*sp12*pow(sp23,5) + 396*
				pow(mz,2)*pow(sp13,4)*pow(sp23,2) - 792*pow(mz,2)*pow(sp13,3)*
				pow(sp23,3) + 396*pow(mz,2)*pow(sp13,2)*pow(sp23,4) - 7200*pow(
				sp12,4)*pow(sp13,3) - 18720*pow(sp12,4)*pow(sp13,2)*sp23 - 18720*
				pow(sp12,4)*sp13*pow(sp23,2) - 7200*pow(sp12,4)*pow(sp23,3) - 
				9624*pow(sp12,3)*pow(sp13,4) - 30936*pow(sp12,3)*pow(sp13,3)*sp23
				- 41040*pow(sp12,3)*pow(sp13,2)*pow(sp23,2) - 30936*pow(sp12,3)*
				sp13*pow(sp23,3) - 9624*pow(sp12,3)*pow(sp23,4) - 9624*pow(
				sp12,2)*pow(sp13,5) - 33120*pow(sp12,2)*pow(sp13,4)*sp23 - 50616*
				pow(sp12,2)*pow(sp13,3)*pow(sp23,2) - 50616*pow(sp12,2)*pow(
				sp13,2)*pow(sp23,3) - 33120*pow(sp12,2)*sp13*pow(sp23,4) - 9624*
				pow(sp12,2)*pow(sp23,5) - 7200*sp12*pow(sp13,6) - 20160*sp12*pow(
				sp13,5)*sp23 - 29344*sp12*pow(sp13,4)*pow(sp23,2) - 33472*sp12*
				pow(sp13,3)*pow(sp23,3) - 29344*sp12*pow(sp13,2)*pow(sp23,4) - 
				20160*sp12*sp13*pow(sp23,5) - 7200*sp12*pow(sp23,6) + 396*pow(
				sp13,5)*pow(sp23,2) - 396*pow(sp13,4)*pow(sp23,3) - 396*pow(
				sp13,3)*pow(sp23,4) + 396*pow(sp13,2)*pow(sp23,5),155925*pow(
				mz,4));
				return ampsq;
		}
		default:
			cerr << "No LO amplitude squared defined for order 1/m_t^ " << inv_mt_pow << "." << endl;
			exit(1);
	}
	return 0;
}


double LO(const double xs[], double sqrs, std::function<double(double)> get_pdfs, const channel * ch, unsigned int inv_mt_pow, bool check_mzh_cutoff){
	if(use_mt_threshold && inv_mt_pow > 0 && sqrs > mt_threshold) return 0;
	
	double s = sqrs*sqrs;
	double pref = phase2prefactor(s,mz,mh)/s/2;
	
	if(pref == 0) return 0;
	
	if(check_mzh_cutoff && use_inv_mass_cutoff && s > inv_mass_cutoff*inv_mass_cutoff) return 0;
	
	//Set mu^2 = s = (p_Z+p_H)^2 or fixed value
	double mu2_R = mu_var_R * mu_var_R, mu2_F = mu_var_F * mu_var_F;
	if(mu_type == 0){
		mu2_R *= fixed_mu_R * fixed_mu_R;
		mu2_F *= fixed_mu_F * fixed_mu_F;
	}
	else{
		mu2_R *= s;
		mu2_F *= s;
	}
	
	pref *= 2; //Factor from measure, dcos -> 2*dx

	double cos = 2*xs[0]-1;
	double sp12 = s/2;
	double kaellenroot = sqrt(kaellen_function(s,mz*mz,mh*mh));
	double sp13 = -(s+mz*mz-mh*mh + kaellenroot*cos)/4;
	double sp23 = -(s+mz*mz-mh*mh - kaellenroot*cos)/4;
	
	//Check cut on Higgs transversal momentum
	if(use_pth_min){
		double pth = sqrt(4/s*sp13*sp23-mz*mz);
		if(pth < pth_min) return 0;
	}
	
	double ampsq = LO_ampsq(inv_mt_pow, sp12, sp13, sp23, ch->get_alpha_s(mu2_R));
	
	ampsq /= 256; //Averaging factor for 2 incoming gluons. 256 = 2^2 (polarisation) * 8^2 (colour)

	return pref*ampsq/pow(mt,inv_mt_pow)*get_pdfs(mu2_F);
}

double LO_0(const double xs[], double sqrs, std::function<double(double)> get_pdfs, const channel * ch){
	return LO(xs, sqrs, get_pdfs, ch, 0);
}

double LO_2(const double xs[], double sqrs, std::function<double(double)> get_pdfs, const channel * ch){
	return LO(xs, sqrs, get_pdfs, ch, 2);
}

double LO_4(const double xs[], double sqrs, std::function<double(double)> get_pdfs, const channel * ch){
	return LO(xs, sqrs, get_pdfs, ch, 4);
}

double LO_6(const double xs[], double sqrs, std::function<double(double)> get_pdfs, const channel * ch){
	return LO(xs, sqrs, get_pdfs, ch, 6);
}

double LO_8(const double xs[], double sqrs, std::function<double(double)> get_pdfs, const channel * ch){
	return LO(xs, sqrs, get_pdfs, ch, 8);
}

double LO_10(const double xs[], double sqrs, std::function<double(double)> get_pdfs, const channel * ch){
	return LO(xs, sqrs, get_pdfs, ch, 10);
}


#include "../src/undef_params.h"
