#include "shared.h"
#include <gsl/gsl_sf_dilog.h>
#include <iostream>
#include <cstdlib>
#include <cmath>

double kaellen_function(double arg1, double arg2, double arg3){
	double tmp = arg1-arg2-arg3;
	return tmp*tmp - 4* arg2*arg3;
	//return arg1*arg1 + arg2*arg2 + arg3*arg3 - 2*arg1*arg2 - 2*arg1*arg3 - 2*arg2*arg3;
}

// Needed for numerical stability when the combination is ~0 in some limit
double sublog(double arg, double add){
	return std::log(arg) + add;
}



double dilog(double arg){
	if(arg > 1){
		std::cout << "Dilog arg > 1 encountered: " << arg << std::endl;
		exit(0);
	}
	return gsl_sf_dilog(arg);
}

double dilogdiff(double arg1, double arg2){
	return dilog(arg1) - dilog(arg2);
}


double dilogsum(double arg1,double arg2){
	return dilog(arg1)+dilog(arg2);
}


double rat(double numer, double denom){
	if(denom == 0){
		std::cout << "Denominator 0 encountered in rat. Numerator was " << numer << std::endl;
	}
	return numer/denom;
}
