#!/bin/bash
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
input=$DIR/../params.def
defs=$DIR/def_params.h
undefs=$DIR/undef_params.h
adds=$DIR/param_add.h

count=0

echo //Do not edit! Automatically generated by params.sh > $defs
echo //Do not edit! Automatically generated by params.sh > $undefs
echo //Do not edit! Automatically generated by params.sh > $adds


#loop over input lines
while read p; do
#trim spaces
	p=$(echo $p | tr -d " ")
#skip comments and empty lines
	if [ -z $p ] ; then continue; fi
	if [ ${p:0:1} == "#" ] ; then continue; fi
	if [ ${p:0:1} == "/" ] ; then continue; fi
	
#replace commas with spaces and put the different fields into an array
	line=$(echo $p | tr "," " ")
	
	array=()
	for x in $line
	do
		array+=($x)
	done
	
	name=${array[0]}
	type=${array[1]}
	default=${array[2]}
	
	echo \#undef $name >> $undefs
	
	
	case "$type" in 
		"double")
			echo "global_params.add_parameter<"$type">("\"$name\", $count, $default");" >> $adds
			echo \#define $name global_params.params_d[$count] >> $defs
			;;
		"int")
			echo "global_params.add_parameter<"$type">("\"$name\", $count, $default");" >> $adds
			echo \#define $name global_params.params_i[$count] >> $defs
			;;
		"string")
			echo "global_params.add_parameter<"$type">("\"$name\", $count, \"$default\"");" >> $adds
			echo \#define $name global_params.params_s[$count] >> $defs
			;;
		*)
			echo Warning: Type not recognised in $input: $type
			echo Supported types are: double, int, string
			;;
	esac 
	
	((count++))
done <$input
